      SUBROUTINE AZIUNFLD(SWEEP,ISEG,ISEGE,MAX_GATES,NBINS,MAX_RAYS,
     1 XXNIQTA,RDTAI,AZ_EL,XXNIQ,NUM_RAYS,VRRAD,IUSEWIND,PAZM)
C SWEEP--Radial velocities with projection of aircraft motion removed
C ISEG and ISEGE--indicate segments between well behaved lines segments
C                 of radial velocity
C MAX_GATES--Dimensioning parameter for storage of VR in radial direction
C NBINS--Actual number of radial bins available for each VR
C MAX_RAYS--Dimensioning parameter for max number of radials in a sweep
C XXNIQTA--Not used--should be removed
C RDTAI--Radius in km of radial velocity from aircraft
C AZ_EL--Azimuth and elevation relative to the track of the aircraft
C XXNIQ--Effective Nyquist velocity (Nyquist velocity for single PRF)
C NUM_RAYS--Actual number of rays in the sweep
C VRRAD--Projection of background (guess) wind field on to radials
C IUSEWIND
C PAZM
      REAL SWEEP(MAX_GATES,MAX_RAYS)
      INTEGER ISEG(MAX_GATES,MAX_RAYS),ISEGE(MAX_GATES,MAX_RAYS)
      REAL RDTAI(MAX_GATES),AZ_EL(2,MAX_RAYS)
      REAL VRRAD(MAX_GATES,MAX_RAYS)
      REAL SWEEPKEEP(512,800)
      REAL PAZM(800),DAZM(800)
      XXNIQ2=XXNIQ*2.
      XXNIQ5=XXNIQ*.5
c      WRITE(6,*)'ENTERED AZINUNFLDGUESS, MAX_GATES,NBINS = ',
c     1 MAX_GATES,NBINS
      DO J=1,NUM_RAYS
       DAZM(J)=PAZM(J)-PAZM(1)
      ENDDO
      DAZM(1)=0.
      IF(NUM_RAYS.GT.1)THEN
       DO J=2,NUM_RAYS
        IF(DAZM(J).LT.DAZM(J-1))THEN
         DAZM(J)=DAZM(J)+360.
        ENDIF
        IF(DAZM(J).LT.DAZM(J-1))THEN
         DAZM(J)=DAZM(J)+360.
        ENDIF
       ENDDO
      ENDIF
c      WRITE(6,*)'DAZM,PAZM = ',(DAZM(I),PAZM(I),I=1,NUM_RAYS)
c      OPEN(77,FILE='lister')
c      IF(IUSEWIND.NE.1)THEN
c      write(77,*)'iusewind = ',iusewind
c      write(77,*)'setting sweepkeep'
c       WRITE(6,*)'ONE'
       DO J=1,NUM_RAYS
        DO I=1,MAX_GATES
         SWEEPKEEP(I,J)=SWEEP(I,J)
        ENDDO
       ENDDO
c      ENDIF
c      WRITE(6,*)'TWO'
      DO J=1,NUM_RAYS
       IFIRST=0
       DO I=1,MAX_GATES
        ISEG(I,J)=0
       ENDDO
       DO I=1,NBINS
        IF(SWEEP(I,J).GT.-800..AND.IFIRST.EQ.0)THEN
C---VERY FIRST GOOD GATE IN RAY
         BEFORE=SWEEP(I,J)
         IFIRST=1
         ISEG(I,J)=-1
         ILAST=I
        ELSEIF(SWEEP(I,J).GT.-800.)THEN
         IF(ABS(SWEEP(I,J)-BEFORE).GE.XXNIQ5.OR.
     1      RDTAI(I)-RDTAI(ILAST).GT..9)THEN
C---DIFFERENCE BETWEEN GATE AND PREVIOUS GOOD GATE MORE THEN .7*VNYQ
c         WRITE(1,*)'SWEEP,BEFORE,XNIQTA7 = ',
c     1               SWEEP(I,J),BEFORE,XXNIQTA
c          WRITE(1,*)'RDTAII,RDTAILAST = ',RDTAI(I),RDTAI(ILAST)
C
C---ISEG AT THE LAST GOOD GATE BEFORE THIS LARGE SHIFT IS SET TO 1
          ISEG(ILAST,J)=1
          ISEG(I,J)=-1
C---ISEG AT THIS BREAKPOINT IS SET TO -1
c          WRITE(1,*)'ILAST,I,DAZM = ',ILAST,I,DAZM(J)
         ENDIF
C
C---GOOD VALUES SET ILAST AND BEFORE TO THESE VALUES
         ILAST=I
         BEFORE=SWEEP(I,J)
        ENDIF
       ENDDO
C---VERY LAST GOOD VALUE GETS AN ISEG VALUE OF 1
       IF(IFIRST.EQ.1)ISEG(ILAST,J)=1
       IISEGE=-1
       DO I=MAX_GATES,1,-1
        IF(ISEG(I,J).EQ.1)THEN
         IISEGE=I
         ISEGE(I,J)=IISEGE
        ELSEIF(ISEG(I,J).EQ.-1)THEN
         ISEGE(I,J)=IISEGE
         IISEGE=-1
        ELSE
         ISEGE(I,J)=IISEGE
        ENDIF
       ENDDO
c       WRITE(77,'(F10.2,2I5,F10.2)')
c     1        (SWEEP(I,J),ISEGE(I,J),I,DAZM(J),I=1,NBINS)       
      ENDDO
c      CLOSE(77)
      IUSETEST=0
      JMAX=0
c      WRITE(6,*)'THREE'
      DO J=1,NUM_RAYS
C       JMAX=J-1
c       WRITE(6,*)'J,DAZM = ',J,DAZM(J)
       IF(DAZM(J).GT.180..AND.DAZM(J).LT.320.)GO TO 777
       I=1
       JMAX=J
       DO WHILE(I.LE.NBINS-1)
c        WRITE(6,*)'I,J,SWEEP(I,J) = ',I,J,SWEEP(I,J)
c        IF(SWEEP(I,J).GT.-800.AND.SWEEP(I,J-1).GT.-800.)THEN
        NSUMTOT=0
        NSUM=0
        SUM=0
        NSUM2=0
        SUM2=0
        IF(SWEEP(I,J).GT.-800.)THEN
         N=ISEGE(I,J)
         II=1
         ITEST=0
2777     IF(J-II.GE.1)THEN
          DO L=I,N
           IF(SWEEP(L,J).GT.-800.)NSUMTOT=NSUMTOT+1
           IF(SWEEP(L,J).GT.-800..AND.VRRAD(L,J).GT.-800.)THEN
            SUM=SUM+SWEEP(L,J)-VRRAD(L,J)
            NSUM=NSUM+1
           ENDIF
           IF(IUSEWIND.EQ.1.AND.
     +        SWEEP(L,J).GT.-800..AND.VRRAD(L,J).GT.-800.)THEN
            SUM2=SUM2+SWEEP(L,J)-VRRAD(L,J)
            NSUM2=NSUM2+1
           ENDIF
          ENDDO
c         write(77,*)'j,i,n,sum,nsum = ',j,i,n,sum,nsum
         ENDIF
         TESTSUM=FLOAT(NSUM)/(FLOAT(NSUMTEST)+.00001)
         IF(NSUM2.GT.5)THEN
          SUMTEST2=SUM2/NSUM2
          IF(ABS(SUMTEST2).GT.XXNIQ*.6)THEN
           NSUM3=1
          ELSE
           NSUM3=0
          ENDIF
         ELSE
          NSUM3=1
         ENDIF
         NSUM3=1
         NTEST=NSUMTOT-NSUM
         IF(NSUM.LE.0.AND.ITEST.LT.3)THEN
          ITEST=ITEST+1
          II=II+1
          GO TO 2777
c         ELSEIF(NSUM3.EQ.1.AND.NSUM.GE.1.AND.NTEST.LT.10)THEN
         ELSEIF(NSUM3.EQ.1.AND.NSUM.GE.1)THEN
          DIFMEAN=SUM/NSUM
          IF(DIFMEAN.GT.XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
c           write(77,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
c     1      j,nsum,difmean,change,xxniq,xxniq2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ELSEIF(DIFMEAN.LT.-XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
c           write(77,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
c     1      j,nsum,difmean,change,xxniq,xxniq2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ENDIF
         ENDIF
         I=N+1
        ELSE
         I=I+1
        ENDIF
       ENDDO        
      ENDDO
c      WRITE(6,*)'FOUR'
777   IF(JMAX.EQ.0)GO TO 678
c      WRITE(6,*)'FIVE'
      DO J=JMAX,1,-1
C       JMAX=J-1
c       WRITE(77,*)'J,DAZM = ',J,DAZM(J)
C       IF(DAZM(J).GT.180..AND.DAZM(J).LT.320.)GO TO 776
       I=1
C       JMAX=J
       DO WHILE(I.LE.NBINS-1)
c        IF(SWEEP(I,J).GT.-800.AND.SWEEP(I,J+1).GT.-800.)THEN
        NSUMTOT=0
        NSUM=0
        SUM=0
        NSUM2=0
        SUM2=0
        IF(SWEEP(I,J).GT.-800.)THEN
         N=ISEGE(I,J)
         II=1
         ITEST=0
2778     IF(J+II.LE.NUM_RAYS)THEN
          DO L=I,N
           IF(SWEEP(L,J).GT.-800.)NSUMTOT=NSUMTOT+1
           IF(SWEEP(L,J).GT.-800.AND.VRRAD(L,J).GT.-800.)THEN
            SUM=SUM+SWEEP(L,J)-VRRAD(L,J)
            NSUM=NSUM+1
           ENDIF
           IF(IUSEWIND.EQ.1.AND.
     +        SWEEP(L,J).GT.-800.AND.VRRAD(L,J).GT.-800.)THEN
            SUM2=SUM2+SWEEP(L,J)-VRRAD(L,J)
            NSUM2=NSUM2+1
           ENDIF
          ENDDO
         ENDIF
c         write(77,*)'j,i,n,sum,nsum = ',j,i,n,sum,nsum
         TESTSUM=FLOAT(NSUM)/(FLOAT(NSUMTOT)+.00001)
         IF(NSUM2.GT.5)THEN
          SUMTEST2=SUM2/NSUM2
          IF(ABS(SUMTEST2).GT.XXNIQ*.6)THEN
           NSUM3=1
          ELSE
           NSUM3=0
          ENDIF
         ELSE
          NSUM3=1
         ENDIF
         NSUM3=1
         NTEST=NSUMTOT-NSUM
         IF(NSUM.LE.0.AND.ITEST.LT.3)THEN
          ITEST=ITEST+1
          II=II+1
          GO TO 2778
         ELSEIF(NSUM3.EQ.1.AND.NSUM.GE.1)THEN
C         ELSEIF(NSUM.GE.1.AND.TESTSUM.GT..74)THEN
          DIFMEAN=SUM/NSUM
          IF(DIFMEAN.GT.XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
c           write(77,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
c     1      j,nsum,difmean,change,xxniq,xxniq2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ELSEIF(DIFMEAN.LT.-XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
c           write(77,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
c     1      j,nsum,difmean,change,xxniq,xxniq2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ENDIF
         ENDIF
         I=N+1
        ELSE
         I=I+1
        ENDIF
       ENDDO        
      ENDDO
776   NSUM=0
      SUM=0.
      DO J=1,JMAX
       DO I=1,NBINS
        IF(SWEEP(I,J).GT.-800.AND.VRRAD(I,J).GT.-800.)THEN
         DIFF=SWEEP(I,J)-VRRAD(I,J)
         NSUM=NSUM+1
         SUM=SUM+DIFF
        ENDIF
       ENDDO
      ENDDO
      IF(NSUM.GT.0)THEN
       IUSETEST=1
       DIFF=SUM/FLOAT(NSUM)
       write(6,*)'difference on right side is ',DIFF
       IF(ABS(DIFF).GT.XXNIQ)THEN
        IF(DIFF.GT.0.)THEN
         VCHANGE=-XXNIQ2
        ELSE
         VCHANGE=XXNIQ2
        ENDIF
        DO J=1,JMAX
         DO I=1,NBINS
          IF(SWEEP(I,J).GT.-800.)THEN
           SWEEP(I,J)=SWEEP(I,J)+VCHANGE
          ENDIF
         ENDDO
        ENDDO
       ENDIF
      ELSE
       IUSETEST=0
      ENDIF
      DO J=1,JMAX
       NSUM=0
       SUM=0
       DO I=1,NBINS
        IF(SWEEP(I,J).GT.-800.AND.VRRAD(I,J).GT.-800.)THEN
         DIFF=SWEEP(I,J)-VRRAD(I,J)
         NSUM=NSUM+1
         SUM=SUM+DIFF
        ENDIF
       ENDDO
       IF(NSUM.GT.0)THEN
        DIFF=SUM/FLOAT(NSUM)
        IF(ABS(DIFF).GT.8.)THEN
         DO I=1,NBINS
          SWEEP(I,J)=-888.88
         ENDDO
        ENDIF
       ENDIF
      ENDDO
      NSUM=0
      SUM=0.
      DO J=1,JMAX
       DO I=1,NBINS
        IF(SWEEP(I,J).GT.-800.AND.VRRAD(I,J).GT.-800.)THEN
         DIFF=SWEEP(I,J)-VRRAD(I,J)
         NSUM=NSUM+1
         SUM=SUM+DIFF
        ENDIF
       ENDDO
      ENDDO
      IF(NSUM.GT.0)THEN
       IUSETEST=1
       DIFF=SUM/FLOAT(NSUM)
       write(6,*)'second difference on right side is ',DIFF
      ENDIF
      IF(IUSEWIND.NE.1.OR.IUSETEST.NE.1)THEN
       NSUM=0
       SUM=0
       DO J=1,JMAX
        DO I=1,NBINS
         IF(SWEEP(I,J).GT.-800.AND.SWEEPKEEP(I,J).GT.-800.)THEN
          SUM=SUM+SWEEP(I,J)-SWEEPKEEP(I,J)
          NSUM=NSUM+1
         ENDIF
        ENDDO
       ENDDO
c       write(77,*)'iusewind,sum,nsum = ',iusewind,sum,nsum
       IF(NSUM.GT.0)THEN
        DIFFMEAN=SUM/NSUM
        CHANGE=0.
        IF(DIFFMEAN.GT.XXNIQ)THEN
         CHANGE=-XXNIQ2
        ELSEIF(DIFFMEAN.LT.-XXNIQ)THEN
         CHANGE=XXNIQ2
        ENDIF
        if(abs(change).gt..001)write(6,*)'right change = ',change
        IF(CHANGE.NE.0.)THEN
c         write(77,*)'changing'
         DO J=1,JMAX
          DO I=1,NBINS
           IF(SWEEP(I,J).GT.-800.)THEN
            SWEEP(I,J)=SWEEP(I,J)+CHANGE
           ENDIF
          ENDDO
         ENDDO
        ENDIF
       ENDIF
      ENDIF
678   IUSETEST=0
      JMIN=0
      DO J=NUM_RAYS,1,-1
c       JMIN=J+1
c       WRITE(77,*)'J,DAZM = ',J,DAZM(J)
       IF(DAZM(J).LT.180..AND.DAZM(J).GT.40.)GO TO 778
       I=1
       JMIN=J
       DO WHILE(I.LE.NBINS-1)
C        IF(SWEEP(I,J).GT.-800.AND.SWEEP(I,J+1).GT.-800.)THEN
        NSUMTOT=0
        NSUM=0
        SUM=0
        NSUM2=0
        SUM2=0
        IF(SWEEP(I,J).GT.-800.)THEN
         N=ISEGE(I,J)
         II=1
         ITEST=0
1777     IF(J+II.LE.NUM_RAYS)THEN
          DO L=I,N
           IF(SWEEP(I,J).GT.-800.)NSUMTOT=NSUMTOT+1
           IF(SWEEP(L,J).GT.-800.AND.VRRAD(L,J).GT.-800.)THEN
            SUM=SUM+SWEEP(L,J)-VRRAD(L,J)
            NSUM=NSUM+1
c            WRITE(77,*)'one,L,J,II,J+II,SWEEP(L,J),SWEEP(L,J+II),',
c     +            L,J,II,J+II,SWEEP(L,J),SWEEP(L,J+II)
c      WRITE(77,*)'one,L,J,SWEEPKEEP(L,J),SWEEPKEEP(L,J+II),',
c     +            L,J,II,J+II,SWEEPKEEP(L,J),SWEEPKEEP(L,J+II)
           ENDIF
           IF(IUSEWIND.EQ.1.AND.
     +        SWEEP(L,J).GT.-800.AND.VRRAD(L,J).GT.-800.)THEN
            SUM2=SUM2+SWEEP(L,J)-VRRAD(L,J)
            NSUM2=NSUM2+1
           ENDIF
          ENDDO
c          WRITE(77,*)'J,I,N,SUM,NSUM = ',J,I,N,SUM,NSUM
         ENDIF
         TESTSUM=FLOAT(NSUM)/(FLOAT(NSUMTOT)+.00001)
         IF(NSUM2.GT.5)THEN
          SUMTEST2=SUM2/NSUM2
          IF(ABS(SUMTEST2).GT.XXNIQ*.6)THEN
           NSUM3=1
          ELSE
           NSUM3=0
          ENDIF
         ELSE
          NSUM3=1
         ENDIF
         NSUM3=1
         NTEST=NSUMTOT-NSUM
         IF(NSUM.LE.0.AND.ITEST.LT.3)THEN
          ITEST=ITEST+1
          II=II+1
          GO TO 1777
         ELSEIF(NSUM3.EQ.1.AND.NSUM.GE.1)THEN
c         ELSEIF(NSUM3.EQ.1.AND.NSUM.GE.1.AND.NTEST.LT.10)THEN
C         ELSEIF(NSUM.GE.1.AND.TESTSUM.GT..74)THEN
          IUSETEST=1
          DIFMEAN=SUM/NSUM
          IF(DIFMEAN.GT.XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
c           write(77,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
c     1      j,nsum,difmean,change,xxniq,xxniq2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ELSEIF(DIFMEAN.LT.-XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
c           write(77,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
c     1      j,nsum,difmean,change,xxniq,xxniq2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ENDIF
         ENDIF
         I=N+1
        ELSE
         I=I+1
        ENDIF
       ENDDO        
      ENDDO
778   IF(JMIN.EQ.0)GO TO 679
      DO J=JMIN,NUM_RAYS
c       JMIN=J+1
c       WRITE(77,*)'J,DAZM = ',J,DAZM(J)
       IF(DAZM(J).LT.180..AND.DAZM(J).GT.40.)GO TO 779
       I=1
C       JMIN=J
       DO WHILE(I.LE.NBINS-1)
C        IF(SWEEP(I,J).GT.-800.AND.SWEEP(I,J-1).GT.-800.)THEN
        NSUMTOT=0
        NSUM=0
        SUM=0
        NSUM2=0
        SUM2=0
        IF(SWEEP(I,J).GT.-800.)THEN
         N=ISEGE(I,J)
         II=1
         ITEST=0
1778     IF(J-II.GE.1)THEN
          DO L=I,N
           IF(SWEEP(L,J).GT.-800.)NSUMTOT=NSUMTOT+1
           IF(SWEEP(L,J).GT.-800.AND.VRRAD(L,J).GT.-800.)THEN
            SUM=SUM+SWEEP(L,J)-VRRAD(L,J)
            NSUM=NSUM+1
c            WRITE(77,*)'two,L,J,II,J-II,SWEEP(L,J),SWEEP(L,J-II) = ',
c     +            L,J,II,J-II,SWEEP(L,J),SWEEP(L,J-II)
           ENDIF
           IF(IUSEWIND.EQ.1.AND.
     +        SWEEP(L,J).GT.-800.AND.VRRAD(L,J).GT.-800.)THEN
            SUM2=SUM2+SWEEP(L,J)-VRRAD(L,J)
            NSUM2=NSUM2+1
           ENDIF
          ENDDO
c          WRITE(77,*)'J,I,N,SUM,NSUM = ',J,I,N,SUM,NSUM
         ENDIF
         TESTSUM=FLOAT(NSUM)/(FLOAT(NSUMTOT)+.00001)
         IF(NSUM2.GT.5)THEN
          SUMTEST2=SUM2/NSUM2
          IF(ABS(SUMTEST2).GT.XXNIQ*.6)THEN
           NSUM3=1
          ELSE
           NSUM3=0
          ENDIF
         ELSE
          NSUM3=1
         ENDIF
         NSUM3=1
         NTEST=NSUMTOT-NSUM
         IF(NSUM.LE.0.AND.ITEST.LT.3)THEN
          ITEST=ITEST+1
          II=II+1
          GO TO 1778
         ELSEIF(NSUM3.EQ.1.AND.NSUM.GE.1)THEN
c         ELSEIF(NSUM3.EQ.1.AND.NSUM.GE.1.AND.NTEST.LT.10)THEN
C         ELSEIF(NSUM.GE.1.AND.TESTSUM.GT..74)THEN
          IUSETEST=1
          DIFMEAN=SUM/NSUM
          IF(DIFMEAN.GT.XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
c           write(77,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
c     1      j,nsum,difmean,change,xxniq,xxniq2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ELSEIF(DIFMEAN.LT.-XXNIQ)THEN
           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
c           write(77,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
c     1      j,nsum,difmean,change,xxniq,xxniq2
           DO L=I,N
            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
           ENDDO
          ENDIF
         ENDIF
         I=N+1
        ELSE
         I=I+1
        ENDIF
       ENDDO        
      ENDDO
779   NSUM=0
      SUM=0.
      DO J=JMIN,NUM_RAYS
       DO I=1,NBINS
        IF(SWEEP(I,J).GT.-800.AND.
     1      VRRAD(I,J).GT.-800.)THEN
         DIFF=SWEEP(I,J)-VRRAD(I,J)
         NSUM=NSUM+1
         SUM=SUM+DIFF
        ENDIF
       ENDDO
      ENDDO
      IF(NSUM.GT.0)THEN
       IUSETEST=1
       DIFF=SUM/FLOAT(NSUM)
       write(6,*)'difference on left side is ',DIFF
       IF(ABS(DIFF).GT.XXNIQ)THEN
        IF(DIFF.GT.0.)THEN
         VCHANGE=-XXNIQ2
        ELSE
         VCHANGE=XXNIQ2
        ENDIF
        DO J=JMIN,NUM_RAYS
         DO I=1,NBINS
          IF(SWEEP(I,J).GT.-800.)THEN
           SWEEP(I,J)=SWEEP(I,J)+VCHANGE
          ENDIF
         ENDDO
        ENDDO
       ENDIF
      ELSE
       IUSETEST=0
      ENDIF
      DO J=JMIN,NUM_RAYS
       NSUM=0
       SUM=0
       DO I=1,NBINS
        IF(SWEEP(I,J).GT.-800.AND.
     1      VRRAD(I,J).GT.-800.)THEN
         DIFF=SWEEP(I,J)-VRRAD(I,J)
         NSUM=NSUM+1
         SUM=SUM+DIFF
        ENDIF
       ENDDO
       IF(NSUM.GT.0)THEN
        DIFF=SUM/FLOAT(NSUM)
        IF(ABS(DIFF).GT.8.)THEN
         DO I=1,NBINS
          SWEEP(I,J)=-888.88
         ENDDO
        ENDIF
       ENDIF
      ENDDO
      NSUM=0
      SUM=0.
      DO J=JMIN,NUM_RAYS
       DO I=1,NBINS
        IF(SWEEP(I,J).GT.-800.AND.
     1      VRRAD(I,J).GT.-800.)THEN
         DIFF=SWEEP(I,J)-VRRAD(I,J)
         NSUM=NSUM+1
         SUM=SUM+DIFF
        ENDIF
       ENDDO
      ENDDO
      IF(NSUM.GT.0)THEN
       IUSETEST=1
       DIFF=SUM/FLOAT(NSUM)
       write(6,*)'second difference on left side is ',DIFF
      ENDIF
      IF(IUSEWIND.NE.1.OR.IUSETEST.NE.1)THEN
       NSUM=0
       SUM=0
       DO J=JMIN,NUM_RAYS
        DO I=1,NBINS
         IF(SWEEP(I,J).GT.-800.AND.SWEEPKEEP(I,J).GT.-800.)THEN
          SUM=SUM+SWEEP(I,J)-SWEEPKEEP(I,J)
          NSUM=NSUM+1
         ENDIF
        ENDDO
       ENDDO
c       WRITE(6,*)'LEFT SIDE SUM,NSUM = ',SUM,NSUM
       IF(NSUM.GT.0)THEN
        DIFFMEAN=SUM/NSUM
        CHANGE=0.
        IF(DIFFMEAN.GT.XXNIQ)THEN
         CHANGE=-XXNIQ2
        ELSEIF(DIFFMEAN.LT.-XXNIQ)THEN
         CHANGE=XXNIQ2
        ENDIF
        if(abs(change).gt..001)write(6,*)'left change = ',change
        IF(CHANGE.NE.0.)THEN
c         write(77,*)'changing'
         DO J=JMIN,NUM_RAYS
          DO I=1,NBINS
           IF(SWEEP(I,J).GT.-800.)THEN
            SWEEP(I,J)=SWEEP(I,J)+CHANGE
           ENDIF
          ENDDO
         ENDDO
        ENDIF
       ENDIF
      ENDIF
c      CLOSE(77)
679   VNYQ=XXNIQ
      DO JJ=1,NUM_RAYS
       DO II=1,NBINS
        IF(SWEEP(II,JJ).GT.-800..AND.VRRAD(II,JJ).GT.-800.)THEN
         DIFF=SWEEP(II,JJ)-VRRAD(II,JJ)
c         if(abs(diff).gt.0.)then
c          write(6,*)'ii,jj,diff,vnyq,sweep,vrrad = ',ii,jj,diff,vnyq,
c     +    sweep(ii,jj),vrrad(ii,jj)
c         endif
         IF(ABS(DIFF).GT..5*VNYQ.OR.ABS(DIFF).GT.8.)THEN
          SWEEP(II,JJ)=-888.88
         ENDIF
        ENDIF
       ENDDO
      ENDDO
      RETURN
      END
